extends Resource
class_name DragonOutfit


@export var outfits: Array[Texture2D]
var index: int = 0


func _init(outfits: Array[Texture2D] = []):
	self.outfits = outfits


func pick_next() -> Texture2D:
	index += 1
	index %= (len(outfits) + 1)
	if index == 0:
		return null
	
	return outfits[index - 1]


func get_index(texture: Texture2D) -> int:
	return outfits.find(texture)


func get_texture(index: int) -> Texture2D:
	if index < 0 or index >= len(outfits):
		return null
	
	return outfits[index]
